<?php

    class DisplayedVideoProduct
    {
        public static function getDisplayedVideoProduct($idProduct)
        {
            self::setDefaultDatabaseOption();
            $option = Wp_caller::getInstance()->get_data(Wp_caller::DISPLAYED_VIDEO_PODUCT);
            if (isset($option[$idProduct])) {
                return $option[$idProduct];
            }
            throw new Exception("Not found");
        }

        public static function setDisplayedVideoProduct($idProduct, $idVideo)
        {
            self::setDefaultDatabaseOption();
            $option = Wp_caller::getInstance()->get_data(Wp_caller::DISPLAYED_VIDEO_PODUCT);
            $option[$idProduct] = $idVideo;
            Wp_caller::getInstance()->save_data(Wp_caller::DISPLAYED_VIDEO_PODUCT, $option);
        }

        // Si une vidéo est supprimée, et est la vidéo affichée pour un produit, on change cette vidéo par la derniere crée
        public static function removeDisplayedVideoProduct($idVideo)
        {
            self::setDefaultDatabaseOption();
            $option = Wp_caller::getInstance()->get_data(Wp_caller::DISPLAYED_VIDEO_PODUCT);
            foreach ($option as $productID => $videoID) {
                if ($idVideo == $videoID) {
                    try {
                        $option[$productID] = self::getLastIdVideoForProduct($productID);
                    } catch (Exception $ignore) {
                        unset($option[$productID]);
                    }
                }
            }
            Wp_caller::getInstance()->save_data(Wp_caller::DISPLAYED_VIDEO_PODUCT, $option);
        }

        private static function setDefaultDatabaseOption()
        {
            if (!Wp_caller::getInstance()->get_data(Wp_caller::DISPLAYED_VIDEO_PODUCT)) {
                Wp_caller::getInstance()->save_data(Wp_caller::DISPLAYED_VIDEO_PODUCT, array());
            }
        }

        private static function getLastIdVideoForProduct($idProduct)
        {
            $demandeManager = new DemandeManager(Wp_caller::getInstance());
            $videosDatabase = $demandeManager->getLocalDemandes("SELECT `id_demande` FROM %s WHERE `flag` = 'completed' AND  `product_id` = " . $idProduct . " ORDER BY `id_demande` DESC  LIMIT 1 ");
            if (isset($videosDatabase[0]) && $videosDatabase[0] instanceof DemandeEntity) {
                return $videosDatabase[0]->getIdDemande();
            }
            throw new Exception("Not found");
        }
    }
