<?php

namespace Controllers;

use Classes\FormBuilder;
use Classes\Tools;
use Classes\Wp_caller;
use Kernel\API\Manager\DigitalSignageException;
use Kernel\API\Manager\ForfaitManager;
use Kernel\Translations\Translate;

class ConnexionController extends Controller
{
    public function generatePage()
    {
        $this->displayLoginForm();
    }


    private function displayLoginForm()
    {

        //Création du formulaire de contact
        $form = new FormBuilder("formualireDeConnexion", Translate::getTraduction("Connexion"));

        //Ajout des champs du formulaire
        $form->addChamp(
            $form->generateField()
                 ->setId("userToken")
                 ->setLabel(Translate::getTraduction("Entrer_token_connexion"))
                 ->setName("userToken")
                 ->setType("text")
                 ->setValue("")
        );


        //ajout de l'oubli de mot de passe et de la création de contre
        $form->addExtraLink(Translate::getTraduction("Creer_compte_ds4"), "https://www.acacia-dynamic.com/FR/index.php");

        //Récuperation du submit
        if ($form->isSubmit()) {
            $token = $form->getDatas()['userToken'];

            try {
                ForfaitManager::instance()->clearUserMessages();
                $user = ForfaitManager::instance()->getForfait($token, true);

                if ($user) {
                    $_SESSION['Success'][] = Translate::getTraduction("Connexion_compte_etablie");
                    ( new Wp_caller() )->save_data(Wp_caller::FORFAIT, $user);
                    $_SESSION['Errors'] = array();
                    Tools::redirectAdmin("presentation");
                } else {
                    $_SESSION['Errors'] = array_merge(($_SESSION['Errors']) ?: array(), ForfaitManager::instance()->getUserMessages());
                }
            } catch (DigitalSignageException $e) {
                $e->echoError();
            }
        }

        //Affichage de la vue de connexion
        $this->assign(array(
            'formConnection' => $form,
        ));

        $this->setWPTemplate("Account/login");
    }
}
