<?php

require_once __DIR__ . "/../Kernel/Translations/DigitalSignageTranslate.php";
require_once __DIR__ . "/../Kernel/API/Manager/ForfaitManager.php";
require_once __DIR__ . "/../Kernel/API/Manager/ForfaitManager.php";
require_once "Controller_i.php";

    if (!class_exists("Smarty")) {
        require_once __DIR__ . "/../vendor/smarty/smarty/libs/Smarty.class.php";
    }


abstract class DigitalSignageController extends Smarty implements Controller_i
{
    protected function setWPTemplate($link)
    {
        $this->setGlonals();
        $this->checkUpdate();
        $this->checkWooCommerceInstance();
        $this->trialMessage();
        $this->my_admin_notices();

        try {
            $this->assign('t', get_class(new DigitalSignageTranslate()));
            $this->display(plugin_dir_path(__FILE__) . "../Views/templates/admin/" . $link . ".tpl");
        } catch (\SmartyException  $e) {
            echo ($e->getMessage());
        } catch (\Exception  $e) {
            echo ($e->getMessage());
        }
    }

    public function my_admin_notices()
    {

        //array_unique supprimes les doublons pouvans etre generés dans le main du module (digitalsignage.php) car il est executé plusieurs fois avant l'ouverture d'une page.
        $errors = array_unique((isset($_SESSION['Errors'])) ? $_SESSION['Errors'] : array());
        foreach ($errors as $error) {
            echo ('<div style="font-size: 1.2em" class="error notice is-dismissible auto-dismiss"><p>' . $error . '</p></div>');
        }

        //array_unique supprimes les doublons pouvans etre generés dans le main du module (digitalsignage.php) car il est executé plusieurs fois avant l'ouverture d'une page.
        $success = array_unique((isset($_SESSION['Success'])) ? $_SESSION['Success'] : array());
        foreach ($success as $succes) {
            echo ('<div style="font-size: 1.2em" class="updated notice is-dismissible auto-dismiss"><p>' . $succes . '</p></div>');
        }

        unset($_SESSION['Errors']);
        unset($_SESSION['Success']);
    }

    private function checkWooCommerceInstance()
    {
        if (!Tools_DS4::isPrestashop()) {
            if (!in_array('woocommerce/woocommerce.php', apply_filters('active_plugins', get_option('active_plugins'))) || !class_exists('WooCommerce')) {
                $_SESSION['Errors'][] = DigitalSignageTranslate::getTraduction("Extension_wooCommerce_pas_installe", DigitalSignageTranslate::getTraduction("Digital_Signage_4"));
            }
        }
    }

    private function setGlonals()
    {
        if (! isset($_SESSION['Errors'])) {
            $_SESSION['Errors'] = array();
        }
        if (! isset($_SESSION['Success'])) {
            $_SESSION['Success'] = array();
        }
    }

    private function trialMessage()
    {
        $forfait = ForfaitManager::instance()->getForfait();

        if ($forfait && $forfait->getTrial() == true) {
            echo ('<div style="font-size: 1.2em; border-left: 4px solid #25b9d7;" class="info notice is-dismissible auto-dismiss"><p>');
            echo (DigitalSignageTranslate::getTraduction("Message_compte_essai", DigitalSignageTranslate::getTraduction("Digital_Signage_4")));
            echo ('<br>'.DigitalSignageTranslate::getTraduction("Message_upgrade_compte", Tools_DS4::getAcaciaRedirectionPageUrl("account")).'</p></div>');
        }
    }

    private function checkUpdate(){
    }
}
